#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <gtk/gtk.h>
#include <stdio.h>

#include "callbacks.h"
#include "interface.h"
#include "support.h"

#include "connection.h"
#include "mainwin.h"
#include "rulewin.h"
#include "log.h"
#include "rulewin.h"

gboolean on_connection_window_delete_event(GtkWidget *widget, GdkEvent *event, gpointer user_data) {
    conn_verdict(VERDICT_DROP);
    return TRUE;
}
                                                                                                                                                                                
                                                                                                                                                                                
void on_drop_button_clicked(GtkButton *button, gpointer user_data) {
    conn_verdict(VERDICT_DROP);
}
                                                                                                                                                                                
                                                                                                                                                                                
void on_reject_button_clicked(GtkButton *button, gpointer user_data) {
    conn_verdict(VERDICT_REJECT);
}
                                                                                                                                                                                
                                                                                                                                                                                
void on_accept_button_clicked(GtkButton *button, gpointer user_data) {
    conn_verdict(VERDICT_ACCEPT);
}

void
on_new_rule_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void on_quit_activate(GtkMenuItem *menuitem, gpointer user_data) {
    gtk_main_quit();
}


void on_clear_log_activate(GtkMenuItem *menuitem, gpointer user_data) {
    log_widget_clear();
}


void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_make_rule_button_clicked            (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_default_ask_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_default_reject_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_default_drop_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_default_accept_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void on_sticky_button_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    conn_set_sticky();
}


gboolean on_main_window_delete_event (GtkWidget *widget, GdkEvent *event, gpointer user_data) {
    gtk_main_quit();
    return FALSE;
}


void on_icmp_option_menu_changed(GtkOptionMenu *optionmenu, gpointer user_data) {
    GtkWidget *w;

    w = GTK_WIDGET(g_list_nth_data(gtk_container_get_children(GTK_CONTAINER(gtk_option_menu_get_menu(optionmenu))), gtk_option_menu_get_history(optionmenu)));
    default_icmp_code = GPOINTER_TO_UINT(g_object_get_data(G_OBJECT(w), "icmp_code"));
}


void on_direction_optionmenu_changed(GtkOptionMenu *optionmenu, gpointer user_data) {
    rulewin_set_sensitive(GTK_WIDGET(optionmenu));
}

void on_match_direction_checkbutton_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    rulewin_set_sensitive(GTK_WIDGET(togglebutton));
}


void on_match_interfaces_checkbutton_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    rulewin_set_sensitive(GTK_WIDGET(togglebutton));
}


void on_protocol_optionmenu_changed(GtkOptionMenu *optionmenu, gpointer user_data) {
    rulewin_set_sensitive(GTK_WIDGET(optionmenu));
}


void
on_port_spinbutton_value_changed       (GtkSpinButton   *spinbutton,
                                        gpointer         user_data)
{

}


void on_match_type_checkbutton_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    rulewin_set_sensitive(GTK_WIDGET(togglebutton));
}


void on_src_netmask_checkbutton_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    rulewin_set_sensitive(GTK_WIDGET(togglebutton));
}


void
on_src_netmask_spinbutton_value_changed
                                        (GtkSpinButton   *spinbutton,
                                        gpointer         user_data)
{

}


void
on_src_ip_entry_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void on_match_source_checkbutton_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    rulewin_set_sensitive(GTK_WIDGET(togglebutton));
}


void on_ok_button_clicked(GtkButton *button, gpointer user_data) {
    GtkWidget *rw = GTK_WIDGET(button);
    rulewin_ok(rw);
    rulewin_destroy(rw);
}


void on_cancel_button_clicked(GtkButton *button, gpointer user_data) {
    GtkWidget *rw = GTK_WIDGET(button);
    rulewin_destroy(rw);
}


void on_add_button_clicked(GtkButton *button, gpointer user_data) {
    rulewin_show(NULL);
}


void on_desc_entry_changed(GtkEditable *editable, gpointer user_data) {
    GtkWidget *rw = GTK_WIDGET(editable);
    static gchar desc[256];
    const gchar *p;
    // Yes, the user may insert <> charachters here, but is this tragic?

    p = gtk_entry_get_text(GTK_ENTRY(lookup_widget(rw, "desc_entry")));

    if (!*p)
        p = "<i>New rule</i>";
    
    snprintf(desc, sizeof(desc), "<b><big>%s</big></b>", p);
    gtk_label_set_label(GTK_LABEL(lookup_widget(rw, "desc_label")), desc);
    rulewin_set_sensitive(GTK_WIDGET(editable));
}


void on_bc_radiobutton_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    rulewin_set_sensitive(GTK_WIDGET(togglebutton));
}



void
on_dst_netmask_spinbutton_value_changed
                                        (GtkSpinButton   *spinbutton,
                                        gpointer         user_data)
{

}


void
on_dst_ip_entry_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{

}


void on_match_destination_checkbutton_toggled(GtkToggleButton *togglebutton, gpointer user_data) {
    rulewin_set_sensitive(GTK_WIDGET(togglebutton));
}

